module RegisterModules
   class Engine < ::Rails::Engine
    initializer "register_modules" do 
      OrbitApp.registration "RegisterModules", :type => "ModuleApp" do
        module_label "register_module.register_module"
        base_url File.expand_path File.dirname(__FILE__)
        authorizable
        categorizable
        taggable "RegisteredModule"

        side_bar do
          head_label_i18n 'register_module.register_module', icon_class: "icons-mouse"
          available_for "users"
          active_for_controllers (['admin/register_modules','admin/admin_modules'])
          head_link_path "admin_register_modules_path"

          context_link 'register_module.my',
            :link_path=>"admin_register_modules_path" ,
            :priority=>1,
            :active_for_action=>{'admin/register_modules'=>"index"},
            :available_for => 'users'

          context_link 'register_module.desktop_widgets',
            :link_path=>"admin_register_desktop_widgets_path" ,
            :priority=>2,
            :active_for_action=>{'admin/register_desktop_widgets'=>"index"},
            :available_for => 'users'

           context_link 'register_module.admin_area',
            :link_path=>"admin_admin_modules_path" ,
            :priority=>3,
            :active_for_action=>{'admin/admin_modules'=>"index"},
            :available_for => 'managers'

        end
      end
    end
  end
end
